1 # Common helper routines for test shell scripts -- to be sourced by them
5 #### The following variables are set by "make check". Ensure
6 #### that they are set here so that individual tests can be run
7 #### outside of make. Requires that MH_OBJ_DIR be set on entry.
8 #### Use the result of cd and pwd -P so that the result will agree
9 #### with what getcwd(3) returns.
10 test -d "$MH_OBJ_DIR/test/testdir" || mkdir -p "$MH_OBJ_DIR/test/testdir"
11 test -z "$MH_TEST_DIR" && MH_TEST_DIR
=`cd "$MH_OBJ_DIR/test/testdir" && pwd -P`
13 test -z "$MH_INST_DIR" && MH_INST_DIR
="${MH_TEST_DIR}/inst"
14 test -z "$MH_VERSION" && MH_VERSION
="@VERSION@"
15 test -z "$prefix" && prefix
=@prefix@
16 test -z "$datarootdir" && datarootdir
=@datarootdir@
17 test -z "$exec_prefix" && exec_prefix
=@exec_prefix@
18 test -z "$bindir" && bindir
="@bindir@"
19 test -z "$mandir" && mandir
="@mandir@"
20 test -z "$nmhetcdir" && nmhetcdir
="@sysconfdir@/nmh"
21 #### The following doesn't support running the distcheck version of
22 #### test-mhparam standalone, but only via make distcheck.
23 test -z "$nmhetcdirinst" && nmhetcdirinst
="@nmhetcdirinst@$nmhetcdir"
24 test -z "$nmhlibexecdir" && nmhlibexecdir
="@libexecdir@/nmh"
25 test -z "$supported_locks" && supported_locks
="@supported_locks@"
26 test -z "$default_locking" && default_locking
="@default_locking@"
27 test -z "$MULTIBYTE_ENABLED" && MULTIBYTE_ENABLED
="@MULTIBYTE_ENABLED@"
28 test -z "$ICONV_ENABLED" && ICONV_ENABLED
="@ICONV_ENABLED@"
29 test -z "$OAUTH_SUPPORT" && OAUTH_SUPPORT
="@OAUTH_SUPPORT@"
30 test -z "$CURL_USER_AGENT" && CURL_USER_AGENT
="@CURL_USER_AGENT@"
32 #### If w3m is used, HOME needs to be set, assuming default w3m config.
33 #### So make sure that HOME is set to avoid run-time warning about not
34 #### being able to create config directory.
35 test -z "$HOME" && HOME
=$MH_TEST_DIR
39 unset MAILDROP MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
40 unset MHLDEBUG MHPDEBUG MHWDEBUG PAGER
41 #### Set LC_ALL in individual tests as needed. Unset these so
42 #### that we don't depend on user's settings in other tests.
43 unset LANG LC_ALL LC_CTYPE
45 #### Use a test dir for tmp files when MHTMPDIR applies.
46 MHTMPDIR
=$MH_TEST_DIR/Mail
49 #### If you're reading this .... you can set MH_TEST_NOCLEANUP to prevent
50 #### the test suite from cleaning up the results of a test run, if you need
51 #### to do manual debugging on a test.
55 #### Output just the checksum. If the filename needs to appear on
56 #### the same line, the caller needs to add it. This avoids
57 #### differences due to a leading '*' binary file indicator, for
58 #### text files, on some platforms (Cygwin).
59 @MD5SUM@ $
* | @MD5FMT@
| awk '{print $1}'
62 #### Use built-in $((...)) in test suite if shell supports it.
63 #### Borrowed from configure's as_fn_arith. The result is placed
64 #### in global arith_val.
65 #### Detected at run-time instead of by configure to allow testing
66 #### with different shells.
67 if (eval "test \$(( 1 + 1 )) = 2" 2>/dev
/null
); then
68 eval 'arith_eval () { arith_val=$(( $* )); }'
70 arith_eval
() { arith_val
=`expr "$@" || test $? -eq 1`; }
76 echo "$Test $0 SKIP ($WHY)"
80 # portable implementation of 'which' utility
84 #### Don't need to save current IFS because this function is run in
91 if [ -f "$D/$PROG" -a -x "$D/$PROG" ]; then
92 printf '%s\n' "$D/$PROG"
100 if [ -z "`findprog $1`" ]; then
101 test_skip
"missing $1"
105 # Skip test if none of the offered locales are supported.
108 for locale
in "$@"; do
109 if locale
-a | grep -i "$locale" >/dev
/null
; then
114 test_skip
"no suitable locale available"
117 # Some stuff for doing silly progress indicators
124 arith_eval
$LAST - $FIRST; RANGE
=$arith_val
125 arith_eval
$THIS - $FIRST; PROG
=$arith_val
126 # this automatically rounds to nearest integer
127 arith_eval
100 \
* $PROG / $RANGE; PERC
=$arith_val
128 # note \r so next update will overwrite
129 printf '%3d%%\r' $PERC
137 # don't emit anything if stdout is not connected to a tty.
148 check_for_hard_links
() {
151 printf '' > "${MH_TEST_DIR}/$$-1"
152 xdir_links_supported
=0
153 if link
"${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev
/null
; then
154 hard_links_supported
=1
155 mkdir "${MH_TEST_DIR}/xlinkdir"
156 if link
"${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/xlinkdir/$$-2" 2>/dev
/null
; then
157 xdir_links_supported
=1
160 hard_links_supported
=0
162 rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
163 rm -rf "${MH_TEST_DIR}/xlinkdir"
168 #### Filter that squeezes blank lines, partially emulating GNU cat -s,
169 #### but sufficient for our purpose.
170 #### From http://www-rohan.sdsu.edu/doc/sed.html, compiled by Eric Pement.
175 #### Filter that converts non-breakable space U+00A0 to an ASCII space.
177 sed 's/'"`printf '\\302\\240'`"'/ /g'
180 #### check() requires two arguments, each the name of a file to be
182 #### If the contents are same, the second file is removed. If different,
183 #### global variable "failed" is incremented.
184 #### Optional arguments:
185 #### 'keep first' -- first file is removed unless this is present.
186 #### 'ignore space' -- spacing differences will not be considered
187 #### significant, emulating GNU diff -w. It is assumed that the
188 #### first file has already been run through prepare_space.
189 #### ':' <test name> -- will print '<test name>' in the failure message,
190 #### to make it easier to tell which of multiple tests has failed.
197 while [ $# -gt 0 ]; do
199 'keep first') keepfirst
=1 ;;
200 'ignore space') ignorespace
=1 ;;
201 ':') shift; label
=\'"$*"\'; break ;;
202 *) echo "$0: invalid check() argument \"$1\" in test suite" >&2 ;;
208 if [ "$ignorespace" ]; then
209 #### POSIX diff should support -b.
210 prepare_space
<"$second" | diff -b "$first" - >/dev
/null
&& success
=1
212 cmp -s "$first" "$second" && success
=1
215 if [ "$success" ]; then
216 [ "$keepfirst" ] || rm -f "$first"
220 #### POSIX diff should support -c.
221 diff -c "$first" "$second" || true
223 echo "$0: $label failed, outputs are in $first and $second."
224 failed
=`expr ${failed:-0} + 1`
225 #### Set return status of the function.
231 #### Shortcut to enable use of valgrind: set NMH_VALGRIND environment
232 #### variable (to anything) so run_* will use valgrind.
233 if [ "${NMH_VALGRIND}" -a -z "${NMH_TEST_PREFIX}" ]; then
234 #### Need absolute path to valgrind.supp in case the test does a cd.
235 NMH_TEST_PREFIX
="valgrind --quiet --error-exitcode=1 \
236 --suppressions=`cd ${srcdir} && pwd`/test/valgrind.supp"
239 #### Run test under another program by setting NMH_TEST_PREFIX
240 #### environment variable to, e.g., 'valgrind --quiet'.
243 #### Don't run valgrind on shell built-in.
245 *) ${NMH_TEST_PREFIX} "$@" ;;
250 #### run_test() requires two arguments, the first is a program and
251 #### arguments, the second is its expected one-line output string.
252 #### If the actual output does not match that string:
253 #### an error message is printed and global variable "failed" is incremented;
254 #### if there is an optional third argument, it is used in the error message.
258 #### Don't run valgrind on shell built-in.
259 eval\
*) actual_output
=`$1 2>&1` ;;
260 *) actual_output
=`${NMH_TEST_PREFIX} $1 2>&1` ;;
263 if test x
"$actual_output" != x
"$2"; then
264 echo "$0: ${3:-\"$1\"} expected:" 1>&2
266 echo "but instead got:" 1>&2
267 echo " '$actual_output'" 1>&2
268 failed
=`expr ${failed:-0} + 1`
272 #### Function invoked by trap on exit.
274 #### Save exit status to use as status for this program.
277 #### Clean up test mail space.
278 #### cd to $MH_TEST_DIR before trying to remove its Mail
279 #### subdirectory. rm on Solaris won't remove it if it's in the
280 #### path of the current working directory.
281 test -z "$MH_TEST_NOCLEANUP" && (cd $MH_TEST_DIR; rm -rf "$MH_TEST_DIR"/Mail
)
283 #### Report test name if set, which indicates failure.
284 #### Relies on set -e to invoke the trap which calls
285 #### this function on failure.
287 #### 1) Set test name before running the test, use start_test().
288 #### 2) Unset upon successful completion, use finish_test().
289 if test -n "$nmh_tests_testname"; then
290 echo $nmh_tests_testname failed
293 #### Exit with non-zero status if failure. Failure is defined as either
294 #### non-empty nmh_tests_testname or non-zero exit status on entry to the
296 if test -n "$nmh_tests_testname" -o $status -ne 0; then
297 test $status -ne 0 && exit $status || exit 1
298 test $status -ne 0 && exit 0 || exit 0
302 #### Function to set the test name, and whatever the future brings.
304 nmh_tests_testname
="$1"
307 #### Corresponding function to indicate that the test has finished. It need
308 #### not be called after each test, just the last one in a file.
310 unset nmh_tests_testname
317 MH
="${MH_TEST_DIR}/Mail/.mh_profile"
318 MHMTSCONF
="${MH_INST_DIR}${nmhetcdir}/mts.conf"
319 MH_LIBEXEC_DIR
="${MH_INST_DIR}${nmhlibexecdir}"
320 export MH MHMTSCONF MH_LIBEXEC_DIR
325 if [ -d "${MH_INST_DIR}${bindir}" ]; then
328 (cd "${MH_OBJ_DIR}" &&
329 make DESTDIR
="${MH_INST_DIR}" SETGID_MAIL
= install) ||
332 #### Don't test with sendmail because it would really send the
333 #### mail. If configured to use sendmail, change to smtp instead
334 #### so that we use fakesmtp.
335 #### And set up the maildrop in the test directory so tests don't
336 #### use the user's real maildrop.
337 #### test-slocal needs to look at the original mts.conf, so save it.
338 mv -f "${MHMTSCONF}" "${MHMTSCONF}.old"
339 sed -e 's/mts: *.*/mts: smtp/' \
340 -e "s%mmdfldir: *.*%mmdfldir: ${MH_TEST_DIR}/Mail%" \
341 -e 's%mmdflfil: *.*%mmdflfil: maildrop%' \
342 "${MHMTSCONF}.old" >"${MHMTSCONF}"
345 #### On Solaris, must set PATH after the install!
346 PATH
="${MH_INST_DIR}${bindir}:${PATH}"
349 # clean old test data on exit
353 mkdir -p "$MH_TEST_DIR/Mail" || exit 1
354 cat > "$MH" <<EOF || exit 1
355 Path: ${MH_TEST_DIR}/Mail
356 buildmimeproc: ${MH_INST_DIR}${bindir}/mhbuild
357 fileproc: ${MH_INST_DIR}${bindir}/refile
358 libexecdir: ${MH_LIBEXEC_DIR}
359 mhbuild: -nocontentid
360 mhlproc: ${MH_LIBEXEC_DIR}/mhl
362 postproc: ${MH_LIBEXEC_DIR}/post
363 showmimeproc: ${MH_INST_DIR}${bindir}/mhshow
364 showproc: ${MH_LIBEXEC_DIR}/mhl
365 #: The following aren't currently used by the test suite, but are
366 #: defined here in case they are in the future:
367 mailproc: ${MH_INST_DIR}${bindir}/mhmail
368 rcvstoreproc: ${MH_LIBEXEC_DIR}/rcvstore
369 sendproc: ${MH_INST_DIR}${bindir}/send
370 whatnowproc: ${MH_INST_DIR}${bindir}/whatnow
371 whomproc: ${MH_INST_DIR}${bindir}/whom
372 #: incproc and packproc are defined in config.c but not used by any code.
375 if test -z '@nmhetcdirinst@'; then
376 #### This isn't used with make distcheck, so that we can use it to
377 #### be sure that etc files are not used from an existing nmh
379 #### posh doesn't like "${MH_INST_DIR}${nmhetcdir}"/*, so cd to
380 #### the directory and provide an argument without quotes to cp.
381 (cd "${MH_INST_DIR}${nmhetcdir}/" && cp * "${MH_TEST_DIR}/Mail")
384 folder
-create +inbox
> /dev
/null
385 # create 10 basic messages
386 for i
in 1 2 3 4 5 6 7 8 9 10;
388 cat > $MH_TEST_DIR/Mail
/inbox
/$i <<EOF || exit 1
389 From: Test$i <test$i@example.com>
390 To: Some User <user@example.com>
391 Date: Fri, 29 Sep 2006 00:00:00
392 Message-Id: $i@test.nmh
393 Subject: Testing message $i
395 This is message number $i